Module java.base
Package java.lang.reflect

## Class AccessibleObject

- java.lang.Object
- - java.lang.reflect.AccessibleObject

All Implemented Interfaces:
  AnnotatedElement

Direct Known Subclasses:
  Executable, Field

    public class AccessibleObject
    extends Object
    implements AnnotatedElement

The AccessibleObject class is the base class for Field, Method and Constructor objects. It provides the ability to flag a reflected object as suppressing default Java language access control checks when it is used. The access checks -- module boundaries, public, default (package) access, protected, and private members -- are performed when Fields, Methods or Constructors are used to set or get fields, to invoke methods or to create and initialize new instances of classes, respectively. Unlike access control specified in the The Java™ Language Specification and The Java Virtual Machine Specification, access checks with reflected objects assume `readability`.

Setting the `accessible` flag in a reflected object permits sophisticated applications with sufficient privilege, such as Java Object Serialization or other persistence mechanisms, to manipulate objects in a manner that would normally be prohibited.

By default, a reflected object is not accessible.

Since:
  1.2
See Also:
  `Field`, `Method`, `Constructor`, `ReflectPermission`

### Constructor Summary

Constructors
`protected` `AccessibleObject()` Constructor: only used by the Java Virtual Machine.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`<T extends Annotation> T` `getAnnotation(Class<T> annotationClass)` Returns this element's annotation for the specified type if such an annotation is present, else null.
`Annotation[]` `getAnnotations()` Returns annotations that are present on this element.
`<T extends Annotation> T[]` `getAnnotationsByType(Class<T> annotationClass)` Returns annotations that are associated with this element.
`<T extends Annotation> T` `getDeclaredAnnotation(Class<T> annotationClass)` Returns this element's annotation for the specified type if such an annotation is directly present, else null.
`Annotation[]` `getDeclaredAnnotations()` Returns annotations that are directly present on this element.
`<T extends Annotation> T[]` `getDeclaredAnnotationsByType(Class<T> annotationClass)` Returns this element's annotation(s) for the specified type if such annotations are either directly present or indirectly present.
`boolean` `isAccessible()` Get the value of the `accessible` flag for this object.
`boolean` `isAnnotationPresent(Class<? extends Annotation> annotationClass)` Returns true if an annotation for the specified type is present on this element, else false.
`void` `setAccessible(boolean flag)` Set the `accessible` flag for this object to the indicated boolean value.
`static void` `setAccessible(AccessibleObject[] array, boolean flag)` Convenience method to set the `accessible` flag for an array of objects with a single security check (for efficiency).

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### AccessibleObject

    protected AccessibleObject()

Constructor: only used by the Java Virtual Machine.

### Method Detail

#### setAccessible

    public static void setAccessible(AccessibleObject[] array,
                                     boolean flag)

Convenience method to set the `accessible` flag for an array of objects with a single security check (for efficiency).

This method cannot be used to enable access to an object that is a `member` of a class in a different module to the caller and where the class is in a package that is not exported to the caller's module. Additionally, this method cannot be used to enable access to non-public members of `AccessibleObject` or `Module`.

If there is a security manager, its `checkPermission` method is first called with a `ReflectPermission("suppressAccessChecks")` permission.

A `SecurityException` is also thrown if any of the elements of the input `array` is a `Constructor` object for the class `java.lang.Class` and `flag` is true.

Parameters:
  `array` - the array of AccessibleObjects
  `flag` - the new value for the `accessible` flag in each object
Throws:
  `InaccessibleObjectException` - if access cannot be enabled
  `SecurityException` - if the request is denied.
See Also:
  `SecurityManager.checkPermission(java.security.Permission)`, `ReflectPermission`

#### setAccessible

    public void setAccessible(boolean flag)

Set the `accessible` flag for this object to the indicated boolean value. A value of `true` indicates that the reflected object should suppress Java language access checking when it is used. A value of `false` indicates that the reflected object should enforce Java language access checks while assuming readability (as noted in the class description).

This method cannot be used to enable access to an object that is a `member` of a class in a different module to the caller and where the class is in a package that is not exported to the caller's module. Additionally, this method cannot be used to enable access to non-public members of `AccessibleObject` or `Module`.

If there is a security manager, its `checkPermission` method is first called with a `ReflectPermission("suppressAccessChecks")` permission.

Parameters:
  `flag` - the new value for the `accessible` flag
Throws:
  `InaccessibleObjectException` - if access cannot be enabled
  `SecurityException` - if the request is denied
See Also:
  `SecurityManager.checkPermission(java.security.Permission)`, `ReflectPermission`

#### isAccessible

    public boolean isAccessible()

Get the value of the `accessible` flag for this object.

Returns:
  the value of the object's `accessible` flag

#### getAnnotation

    public <T extends Annotation> T getAnnotation(Class<T> annotationClass)

Description copied from interface: `AnnotatedElement`
Returns this element's annotation for the specified type if such an annotation is present, else null.

Specified by:
  `getAnnotation` in interface `AnnotatedElement`
Type Parameters:
  `T` - the type of the annotation to query for and return if present
Parameters:
  `annotationClass` - the Class object corresponding to the annotation type
Returns:
  this element's annotation for the specified annotation type if present on this element, else null
Throws:
  `NullPointerException` - if the given annotation class is null
Since:
  1.5

#### isAnnotationPresent

    public boolean isAnnotationPresent(Class<? extends Annotation> annotationClass)

Returns true if an annotation for the specified type is present on this element, else false. This method is designed primarily for convenient access to marker annotations.

The truth value returned by this method is equivalent to: `getAnnotation(annotationClass) != null`

The body of the default method is specified to be the code above.

Specified by:
  `isAnnotationPresent` in interface `AnnotatedElement`
Parameters:
  `annotationClass` - the Class object corresponding to the annotation type
Returns:
  true if an annotation for the specified annotation type is present on this element, else false
Throws:
  `NullPointerException` - if the given annotation class is null
Since:
  1.5

#### getAnnotationsByType

    public <T extends Annotation> T[] getAnnotationsByType(Class<T> annotationClass)

Description copied from interface: `AnnotatedElement`
Returns annotations that are associated with this element. If there are no annotations associated with this element, the return value is an array of length 0. The difference between this method and `AnnotatedElement.getAnnotation(Class)` is that this method detects if its argument is a repeatable annotation type (JLS 9.6), and if so, attempts to find one or more annotations of that type by "looking through" a container annotation. The caller of this method is free to modify the returned array; it will have no effect on the arrays returned to other callers.

Specified by:
  `getAnnotationsByType` in interface `AnnotatedElement`
Type Parameters:
  `T` - the type of the annotation to query for and return if present
Parameters:
  `annotationClass` - the Class object corresponding to the annotation type
Returns:
  all this element's annotations for the specified annotation type if associated with this element, else an array of length zero
Throws:
  `NullPointerException` - if the given annotation class is null
Since:
  1.8

#### getAnnotations

    public Annotation[] getAnnotations()

Description copied from interface: `AnnotatedElement`
Returns annotations that are present on this element. If there are no annotations present on this element, the return value is an array of length 0. The caller of this method is free to modify the returned array; it will have no effect on the arrays returned to other callers.

Specified by:
  `getAnnotations` in interface `AnnotatedElement`
Returns:
  annotations present on this element
Since:
  1.5

#### getDeclaredAnnotation

    public <T extends Annotation> T getDeclaredAnnotation(Class<T> annotationClass)

Description copied from interface: `AnnotatedElement`
Returns this element's annotation for the specified type if such an annotation is directly present, else null. This method ignores inherited annotations. (Returns null if no annotations are directly present on this element.)

Specified by:
  `getDeclaredAnnotation` in interface `AnnotatedElement`
Type Parameters:
  `T` - the type of the annotation to query for and return if directly present
Parameters:
  `annotationClass` - the Class object corresponding to the annotation type
Returns:
  this element's annotation for the specified annotation type if directly present on this element, else null
Throws:
  `NullPointerException` - if the given annotation class is null
Since:
  1.8

#### getDeclaredAnnotationsByType

    public <T extends Annotation> T[] getDeclaredAnnotationsByType(Class<T> annotationClass)

Description copied from interface: `AnnotatedElement`
Returns this element's annotation(s) for the specified type if such annotations are either directly present or indirectly present. This method ignores inherited annotations. If there are no specified annotations directly or indirectly present on this element, the return value is an array of length 0. The difference between this method and `AnnotatedElement.getDeclaredAnnotation(Class)` is that this method detects if its argument is a repeatable annotation type (JLS 9.6), and if so, attempts to find one or more annotations of that type by "looking through" a container annotation if one is present. The caller of this method is free to modify the returned array; it will have no effect on the arrays returned to other callers.

Specified by:
  `getDeclaredAnnotationsByType` in interface `AnnotatedElement`
Type Parameters:
  `T` - the type of the annotation to query for and return if directly or indirectly present
Parameters:
  `annotationClass` - the Class object corresponding to the annotation type
Returns:
  all this element's annotations for the specified annotation type if directly or indirectly present on this element, else an array of length zero
Throws:
  `NullPointerException` - if the given annotation class is null
Since:
  1.8

#### getDeclaredAnnotations

    public Annotation[] getDeclaredAnnotations()

Description copied from interface: `AnnotatedElement`
Returns annotations that are directly present on this element. This method ignores inherited annotations. If there are no annotations directly present on this element, the return value is an array of length 0. The caller of this method is free to modify the returned array; it will have no effect on the arrays returned to other callers.

Specified by:
  `getDeclaredAnnotations` in interface `AnnotatedElement`
Returns:
  annotations directly present on this element
Since:
  1.5